<template>
  <v-dialog v-model="showModalStudents" scrollable max-width="700px" persistent>
    <v-card>
      <v-card-text class="pop">
        <v-row>
          <v-col md="12">
            <div class="title text-center">Agregar alumnos a la tutoría</div>
          </v-col>
        </v-row>

        <v-row>
          <v-col>
            <st-search
              md="12"
              text="Buscar por nombre o código de alumno"
              @enter="searchStudent($event)"
            />
            <st-select-table
              :dataInfo="{ headers, items, key }"
              :loading="tableLoading"
              @selected="captureStudent($event)"/>
            <div class="items-box">
              <div v-for="(student, index) in students" :key="student.codigo">
                <v-btn small text @click="deleteStudent(index)">X</v-btn>
                {{ student.nombre }}
              </div>
            </div>
            <div class="content-footer">
              <st-secondary-btn nombre="Cancelar" @click="closeModal()"/>
              <st-primary-btn nombre="Agregar alumnos" :loading="registering" @click="registerStudentsInTutorship()"/>
            </div>
          </v-col>
        </v-row>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
import {mapState} from "vuex";
import DataTablePopup from "./DataTablePopup";
import Search from "./Search";
import SelectTable from "./SelectTable";

export default {
  name: "TutorshipStudentsModal",
  data() { return {
    key: 'idAlumno',
    students: [],
    tableLoading: false,
    registering: false,
  }},
  props:['value'],
  components: {
    'st-data-table': DataTablePopup,
    'st-search': Search,
    'st-select-table': SelectTable,
  },
  computed: {
    ...mapState('tutorships', {
      showModalStudents: (state) => state.showModalStudents,
      headers: (state) => state.studentTableHeaders,
      items: (state) => state.modalStudents,
    }),
  },
  methods: {
    searchStudent(value) {
      const idTutorship = this.$route.params.id;
      this.tableLoading = true;
      this.$store.dispatch('tutorships/searchStudentsToAddInTutorship', {
        idTutorship: idTutorship,
        searchQuery: value
      }).then(() => this.tableLoading = false);
    },
    captureStudent(value) {
      let st = this.students.filter((obj) => obj.idAlumno === value.idAlumno)
      // si no se encuentra en la lista de alumnos, se le agrega a dicha lista
      if (st.length === 0) this.students.push({idAlumno: value.idAlumno, nombre: value.nombre})
    },
    deleteStudent(index){
      this.students.splice(index, 1);
    },
    registerStudentsInTutorship() {
      this.registering = true;
      const idTutorship = this.$route.params.id;
      this.$store.dispatch('tutorships/registerStudentsInTutorship', {
        idTutorship: idTutorship,
        students: this.students
      }).then((res) => {
        this.$store.dispatch('tutorships/updateStudentsInTutorship', {idTutorship: idTutorship, searchQuery: ""});
        this.registering = false;
        this.closeModal();
      });
    },
    closeModal() {
      this.students.splice(0, this.students.length);
      this.searchStudent("");
      this.$store.dispatch('tutorships/closeStudentsModal');
    },
  },
  mounted() {
    this.searchStudent("");
  },
}
</script>

<style scoped>
</style>
